-- **************************************************************************
-- NAME : TitanPanelRightClickMenu_PreparePalsMenu()
-- DESC : <research>
-- **************************************************************************
function TitanPanelRightClickMenu_PreparePalsMenu()
	local info = {};
	local TitanPalsFaction = UnitFactionGroup("player");
	local TitanPalsRealm = GetCVar("realmName");
	local TitanPalsRealmUnit = GetUnitName("player");
	local CurCounts = TitanPanelPals_GetButtonCounts();
	local NumPals, NumPalsOnline = string.match( CurCounts, '(.*):(.*)' )
	if ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) then

		-- this is for whispering a friend
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_WHISPER ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = TitanPalsUtils_ClassToColor("color", Pals_class, Pals_name);
					info.func = palsWisper;
					info.value = Pals_name;
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end

		-- this is for removing a friend from friends list
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_REMOVE ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = TitanPalsUtils_ClassToColor("color", Pals_class, Pals_name);
					info.func = PalsRemove;
					info.value = Pals_name;
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end

		-- This is for group Invites
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_INVITE ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = TitanPalsUtils_ClassToColor("color", Pals_class, Pals_name);
					info.func = PalsInvite;
					info.value = Pals_name;
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end

		-- This is for setting friends note
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_PALS_MENU_NOTE ) then
			local NumPals = GetNumFriends();
			local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
			local friendIndex
			for friendIndex=1, NumPals do
				Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
				if ( Pals_connected ) then
					info = {};
					info.text = TitanPalsUtils_ClassToColor("color", Pals_class, Pals_name);
					info.hasArrow = 1;
					UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
				end
			end
		end
		return;
	end
	if ( UIDROPDOWNMENU_MENU_LEVEL == 3 ) then
		local NumPals = GetNumFriends();
		local Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note
		local friendIndex
		local Realm_name
		for friendIndex=1, NumPals do
			Pals_name, Pals_level, Pals_class, Pals_area, Pals_connected, Pals_status, Pals_note = GetFriendInfo(friendIndex);
			Realm_Name = TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][Pals_name].name;
			if ( UIDROPDOWNMENU_MENU_VALUE == TitanPalsUtils_ClassToColor("color", Pals_class, Realm_Name) ) then
			--Debug line for Notes submenu
				if ( Pals_connected ) then
					if ( Pals_class == "Warrior" ) then
						info = {};
						--Protection
						info.text = "|cffc79c6e"..TITAN_PALS_NOTE_WPROT.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_WPROT;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Arms
						info.text = "|cffc79c6e"..TITAN_PALS_NOTE_WARMS.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_WARMS;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Fury
						info.text = "|cffc79c6e"..TITAN_PALS_NOTE_WFURY.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_WFURY;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Mage" ) then
						info = {};
						--Fire
						info.text = "|cff69ccf0"..TITAN_PALS_NOTE_MFIRE.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_MFIRE;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Frost
						info.text = "|cff69ccf0"..TITAN_PALS_NOTE_MFROS.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_MFROS;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Arcane
						info.text = "|cff69ccf0"..TITAN_PALS_NOTE_MARCA.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_RSUBT;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Paladin" ) then
						info = {};
						--Protection
						info.text = "|cfff58cba"..TITAN_PALS_NOTE_PPROT.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PPROT;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Holy
						info.text = "|cfff58cba"..TITAN_PALS_NOTE_PHOLY.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PHOLY;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Retribution
						info.text = "|cfff58cba"..TITAN_PALS_NOTE_PRETR.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PRETR;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Hunter" ) then
						info = {};
						--Beast Mastery
						info.text = "|cffabd473"..TITAN_PALS_NOTE_HBEAS.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_HBEAS;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Marksmanship
						info.text = "|cffabd473"..TITAN_PALS_NOTE_HMARK.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_HMARK;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Survival
						info.text = "|cffabd473"..TITAN_PALS_NOTE_HSURV.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_HSURV;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Rogue" ) then
						info = {};
						--Assassination
						info.text = "|cfffff569"..TITAN_PALS_NOTE_RASSA.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_RASSA;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Combat
						info.text = "|cfffff569"..TITAN_PALS_NOTE_RCOMB.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_RCOMB;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Subtlety
						info.text = "|cfffff569"..TITAN_PALS_NOTE_RSUBT.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_RSUBT;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Priest" ) then
						info = {};
						--Shadow
						info.text = "|cffffffff"..TITAN_PALS_NOTE_PRSHA.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PRSHA;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Holy
						info.text = "|cffffffff"..TITAN_PALS_NOTE_PRHOL.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PRHOL;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Discipline
						info.text = "|cffffffff"..TITAN_PALS_NOTE_PRDIS.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_PRDIS;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Death Knight" ) then
						info = {};
						--Blood
						info.text = "|cffc41f3b"..TITAN_PALS_NOTE_DKBLO.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DKBLO;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Frost
						info.text = "|cffc41f3b"..TITAN_PALS_NOTE_DKFRO.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DKFRO;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--UnHoly
						info.text = "|cffc41f3b"..TITAN_PALS_NOTE_DKUNH.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DKUNH;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Druid" ) then
						info = {};
						--Balance
						info.text = "|cffff7d0a"..TITAN_PALS_NOTE_DBALA.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DBALA;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Feral Combat
						info.text = "|cffff7d0a"..TITAN_PALS_NOTE_DFERA.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DFERA;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Restoration
						info.text = "|cffff7d0a"..TITAN_PALS_NOTE_DREST.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_DREST;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Shaman" ) then
						info = {};
						--Elemental
						info.text = "|cff2459FF"..TITAN_PALS_NOTE_SELEM.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_SELEM;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Enhancement
						info.text = "|cff2459FF"..TITAN_PALS_NOTE_SENHA.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_SENHA;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Restoration
						info.text = "|cff2459FF"..TITAN_PALS_NOTE_SREST.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_SREST;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
					if ( Pals_class == "Warlock" ) then
						info = {};
						--Elemental
						info.text = "|cff9482C9"..TITAN_PALS_NOTE_LAFFL.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_LAFFL;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Enhancement
						info.text = "|cff9482C9"..TITAN_PALS_NOTE_LDEMO.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_LDEMO;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
						--Restoration
						info.text = "|cff9482C9"..TITAN_PALS_NOTE_LDEST.."|r";
						info.func = PalsNote
						info.value = Pals_name..":"..TITAN_PALS_NOTE_LDEST;
						UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
					end
				end
			end
		end
		return;
	end
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_PALS_ID].menuText);

	if ( NumPalsOnline > "0" ) then
		-- create the title for the Whisper submenu
		info = {};
		info.text = TITAN_PALS_MENU_WHISPER;
		info.hasArrow = 1;
		UIDropDownMenu_AddButton(info);

		-- create the title for the Invite submenu
		info = {};
		info.text = TITAN_PALS_MENU_INVITE;
		info.hasArrow = 1;
		UIDropDownMenu_AddButton(info);

		-- create the title for the Ignore submenu
		info = {};
		info.text = TITAN_PALS_MENU_REMOVE;
		info.hasArrow = 1;
		UIDropDownMenu_AddButton(info);

		-- create the title for the Note submenu
		info = {};
		info.text = TITAN_PALS_MENU_NOTE;
		info.hasArrow = 1;
		UIDropDownMenu_AddButton(info);

		TitanPanelRightClickMenu_AddSpacer();

	end

	-- ShowOffLine Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWOFFLINE;
	info.func = TitanPals_ShowOffline;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowOffline");
	UIDropDownMenu_AddButton(info);

	-- ShowIgnored Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWIGNORED;
	info.func = TitanPals_ShowIgnored;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowIgnored");
	UIDropDownMenu_AddButton(info);

	-- ShowClass Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWCLASS;
	info.func = TitanPals_ShowClass;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowClass");
	UIDropDownMenu_AddButton(info);

	-- ShowNote Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SHOWNOTE;
	info.func = TitanPals_ShowNote;
	info.checked = TitanGetVar(TITAN_PALS_ID, "ShowNote");
	UIDropDownMenu_AddButton(info);

	-- NoAlts ToolTip Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_NOALTS;
	info.func = TitanPals_NoAltsToolTip;
	info.checked = TitanGetVar(TITAN_PALS_ID, "NoAlts");
	UIDropDownMenu_AddButton(info);

	-- Sync Alts To Friends List Setting Option
	info = {};
	info.text = TITAN_PALS_MENU_SYNCALTS;
	info.func = TitanPanelPals_SyncAlts;
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer();

	local TitanUser = TitanPalsRealmUnit.."@"..TitanPalsRealm;
	if ( TitanUser == TITAN_PALS_AUTHOR ) then 
		info = {};
		info.text = TITAN_PALS_MENU_DEV;
		info.func = TitanPals_DevDebug;
		info.checked = TitanGetVar(TITAN_PALS_ID, "Debug");
		UIDropDownMenu_AddButton(info);
	
		TitanPanelRightClickMenu_AddSpacer();

	end

	-- Upgrades
	if ( not TitanPalsVars["Version"] or TitanPalsVars["Version"] ~= TITAN_PALS_ADDVER ) then
		info = {};
		info.text = TitanPalsUtils_GetColoredText("green", TITAN_PALS_MENU_UPGRADE);
		info.func = TitanPalsUtils_Upgrade;
		UIDropDownMenu_AddButton(info);

		TitanPanelRightClickMenu_AddSpacer();

	end

	TitanPanelRightClickMenu_AddToggleIcon(TITAN_PALS_ID);
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_PALS_ID);

	-- default Titan Panel right-click menu options
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_PALS_ID, TITAN_PANEL_MENU_FUNC_HIDE);

end
-- **************************************************************************
-- NAME : TitanPals_ShowOffline()
-- DESC : <research>
-- **************************************************************************
function TitanPals_ShowOffline()
   TitanToggleVar(TITAN_PALS_ID, "ShowOffline");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : TitanPals_ShowIgnored()
-- DESC : <research>
-- **************************************************************************
function TitanPals_ShowIgnored()
   TitanToggleVar(TITAN_PALS_ID, "ShowIgnored");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : TitanPals_ShowClass()
-- DESC : <research>
-- **************************************************************************
function TitanPals_ShowClass()
   TitanToggleVar(TITAN_PALS_ID, "ShowClass");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : TitanPals_MouseUpdate()
-- DESC : <research>
-- **************************************************************************
function TitanPals_MouseUpdate()
   TitanToggleVar(TITAN_PALS_ID, "MouseUpdate");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : TitanPals_ShowNote()
-- DESC : <research>
-- **************************************************************************
function TitanPals_ShowNote()
   TitanToggleVar(TITAN_PALS_ID, "ShowNote");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : TitanPals_NoAltsToolTip()
-- DESC : <research>
-- **************************************************************************
function TitanPals_NoAltsToolTip()
   TitanToggleVar(TITAN_PALS_ID, "NoAlts");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : TitanPals_SyncAlts()
-- DESC : <research>
-- **************************************************************************
function TitanPals_SyncAlts()
   TitanToggleVar(TITAN_PALS_ID, "TitanPalsSync");
   TitanPanelButton_UpdateButton(TITAN_PALS_ID);
end

-- **************************************************************************
-- NAME : PalsRemove()
-- DESC : <research>
-- **************************************************************************
function PalsRemove()
	local IgnoreRemove = this.value;
	RemoveFriend( this.value );
end

-- **************************************************************************
-- NAME : PalsInvite()
-- DESC : <research>
-- **************************************************************************
function PalsInvite()
	InviteUnit( this.value );
end

-- **************************************************************************
-- NAME : PalsNote()
-- DESC : <research>
-- **************************************************************************
function PalsNote()
	local Pals_name, Pals_note = string.match( this.value, '(.*):(.*)' );
	SetFriendNotes( Pals_name, Pals_note )
end