-- **************************************************************************
-- NAME : TitanPanelPalsButton_SetTooltipText()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPalsButton_SetTooltipText()
	GameTooltip:SetText(TITAN_PALS_TOOLTIP, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	local NumPals = GetNumFriends();
	local OnlinePals = 0;
	local OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_connected, OnlinePals_status, OnlinePals_note
	local OnlinefriendIndex
	local TitanPalsFaction = UnitFactionGroup("player");
	local TitanPalsRealm = GetCVar("realmName");
	local TitanPalsRealmUnit = GetUnitName("player");
	if ( NumPals == 0 ) then GameTooltip:AddLine("Your Pals List Is Currently Empty!!!")
		else for OnlinefriendIndex=1, NumPals do
			OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_connected, OnlinePals_status, OnlinePals_note = GetFriendInfo(OnlinefriendIndex);
			local TitanPals_ColoredNamePlate, TitanPals_AreaInfo
 			if ( not TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][OnlinePals_name] ) then 
				TitanPanelPals_AddPals(OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_note); 
			end
			if ( OnlinePals_connected ) then
				TitanPanelPals_UpdatePals(OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_note);
				TitanPals_ColoredNamePlate = TitanPanelPals_PopulateName(OnlinePals_status, OnlinePals_level, OnlinePals_class, OnlinePals_name);
				TitanPals_AreaInfo = TitanPalsUtils_GetColoredText("normal", OnlinePals_area)
				OnlinePals = OnlinePals + 1;
				if ( TitanGetVar(TITAN_PALS_ID, "ShowNote") ) then
					if ( OnlinePals_note ) then OnlinePals_note = "("..OnlinePals_note..")"; TitanPals_AreaInfo = TitanPalsUtils_GetColoredText("normal", OnlinePals_note).." "..TitanPals_AreaInfo; end
				end
			end
			GameTooltip:AddDoubleLine(TitanPals_ColoredNamePlate, TitanPalsUtils_GetColoredText("highlight", TitanPals_AreaInfo));
		end
		if ( OnlinePals == 0 ) then GameTooltip:AddLine("No Pals Currently Online"); end
	end
	if ( NumPals > 0 ) then
		if ( TitanGetVar(TITAN_PALS_ID, "ShowOffline") ) then
			GameTooltip:AddLine("\n");
			GameTooltip:AddLine(TitanUtils_GetHighlightText(TITAN_PALS_TOOLTIP_OFF));

			local OfflinefriendIndex
			for OfflinefriendIndex=1, NumPals do
				OfflinePals_name, OfflinePals_level, OfflinePals_class, OfflinePals_area, OfflinePals_connected, OfflinePals_status, OfflinePals_note = GetFriendInfo(OfflinefriendIndex);
				OfflinePals_level = TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][OfflinePals_name].level
				OfflinePals_class = TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][OfflinePals_name].class
				OfflinePals_note = TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][OfflinePals_name].note
				TitanPals_ColoredNamePlate = TitanPanelPals_PopulateName(OfflinePals_status, OfflinePals_level, OfflinePals_class, OfflinePals_name)
				TitanPals_AreaInfo = "<Offline>"
				if ( TitanGetVar(TITAN_PALS_ID, "ShowNote") and OfflinePals_note ) then TitanPals_AreaInfo = "("..OfflinePals_note..")"..TitanPals_AreaInfo end
 				if ( not OfflinePals_connected ) then
					if ( TitanGetVar(TITAN_PALS_ID, "NoAlts") and not TitanPalsAlts[TitanPalsFaction][TitanPalsRealm][OfflinePals_name] ) then
						GameTooltip:AddDoubleLine(TitanPals_ColoredNamePlate, TitanPalsUtils_GetColoredText("gray", TitanPals_AreaInfo));
					end
					if ( not TitanGetVar(TITAN_PALS_ID, "NoAlts") ) then 
						GameTooltip:AddDoubleLine(TitanPals_ColoredNamePlate, TitanPalsUtils_GetColoredText("gray", TitanPals_AreaInfo));
					end
				end
			end
		end
		if ( TitanGetVar(TITAN_PALS_ID, "ShowIgnored") ) then
			GameTooltip:AddLine("\n");
			GameTooltip:AddLine(TitanUtils_GetHighlightText(TITAN_PALS_TOOLTIP_IGNORED));
			Numignored = GetNumIgnores();
			local ignoredIndex
			if ( Numignored == 0 ) then GameTooltip:AddLine("Your ignore list is currently empty.");
				else for ignoredIndex=1, Numignored do
					if (not OfflinePals_connected ) then
						local TitanPals_IgnoredTxt =  TitanPalsUtils_GetColoredText("red", "<Ignored>")
						GameTooltip:AddDoubleLine("  "..TitanPalsUtils_GetColoredText("normal", GetIgnoreName(ignoredIndex)), TitanPals_IgnoredTxt);
					end
				end
			end
		end
	end
end

-- **************************************************************************
-- NAME : TitanPanelPals_PopulateName()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_PopulateName(status, level, class, name)
	if ( status ) then status = status.." "; end;
	if (level == 0) then level = "-"; end
	if ( TitanGetVar(TITAN_PALS_ID, "ShowClass") ) then
		return "  "..status.." ("..TitanPalsUtils_GetColoredText("orange", level).." "..TitanPalsUtils_ClassToColor("color", class, class)..") "..name;
	else
		return "  "..status.."("..TitanPalsUtils_GetColoredText("orange", level)..") "..TitanPalsUtils_ClassToColor("color", class, name);
	end
end

-- **************************************************************************
-- NAME : TitanPanelPals_AddPals()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_AddPals(name, level, class, area, note)
	local TitanPalsFaction = UnitFactionGroup("player");
	local TitanPalsRealm = GetCVar("realmName");
	local TitanPalsRealmUnit = GetUnitName("player");
	if ( not TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name] ) then 
		TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name] = {};
		TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].name = name;
		TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].level = level;
		TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].class = class;
		TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].area = area;
		if ( note ) then TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].note = note; end
	end
end

-- **************************************************************************
-- NAME : TitanPanelPals_UpdatePals()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_UpdatePals(name, level, class, area, note)
	local TitanPalsFaction = UnitFactionGroup("player");
	local TitanPalsRealm = GetCVar("realmName");
	local TitanPalsRealmUnit = GetUnitName("player");
	if ( name ) then TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].name = name; end
	if ( level ) then TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].level = level; end
	if ( class ) then TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].class = class; end
	if ( area ) then TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].area = area; end
	if ( note ) then TitanPalsList[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].note = note; end
end

-- **************************************************************************
-- NAME : TitanPanelPals_FixPalsEcho()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_FixPalsEcho(level, class, name)		
	local class = TitanPalsUtils_ClassToColor("color", class, class)
	local name = TitanPalsUtils_ClassToColor("color", class, name)
	return "Fixing Pals ["..name.."] Class = ["..class.."] Level = ["..TitanPalsUtils_GetColoredText("orange", level).."]";
end

-- **************************************************************************
-- NAME : TitanPalsUtils_ClassToColor(class)
-- DESC : <research>
-- **************************************************************************
function TitanPalsUtils_ClassToColor(style, class, name)
	local colorCode;
	if (class == "Warlock") then colorCode = "|cff9482C9";
	elseif (class == "Death Knight") then colorCode = "|cffc41f3b";
	elseif (class == "Hunter") then colorCode = "|cffabd473";
	elseif (class == "Priest") then colorCode = "|cffffffff";
	elseif (class == "Paladin") then colorCode = "|cfff58cba";
	elseif (class == "Mage") then colorCode = "|cff69ccf0";
	elseif (class == "Rogue") then colorCode = "|cfffff569";
	elseif (class == "Druid") then colorCode = "|cffff7d0a";
	elseif (class == "Shaman") then colorCode = "|cff2459FF";
	elseif (class == "Warrior") then colorCode = "|cffc79c6e";
	else colorCode = "|cffFFFFFF";
	end
	if ( style == "color" ) then return colorCode..name..FONT_COLOR_CODE_CLOSE; end
	if ( style == "normal" ) then return name; end
end

-- **************************************************************************
-- NAME : TitanPalsUtils_FixPal()
-- DESC : <research>
-- **************************************************************************
function TitanPalsUtils_FixPal(PN, PC, PL)
	if ( PC == "1" ) then PC = "Warrior"
	elseif ( PC == "2" ) then PC = "Mage"
	elseif ( PC == "3" ) then PC = "Warlock"
	elseif ( PC == "4" ) then PC = "Paladin"
	elseif ( PC == "5" ) then PC = "Priest"
	elseif ( PC == "6" ) then PC = "Hunter"
	elseif ( PC == "7" ) then PC = "Shaman"
	elseif ( PC == "8" ) then PC = "Rogue"
	elseif ( PC == "9" ) then PC = "Druid"
	elseif ( PC == "10" ) then PC = "Death Knight" end
	local printLine = TitanPanelPals_FixPalsEcho(PL, PC, PN)
	TitanPalsUtils_Print(printLine);
	local TPF = UnitFactionGroup("player");
	local TPR = GetCVar("realmName");
	local TPRU = GetUnitName("player");
	TitanPalsList[TPF][TPR][TPRU][PN].class = PC
	TitanPalsList[TPF][TPR][TPRU][PN].level = PL
end

-- **************************************************************************
-- NAME : TitanPalsUtils_GetColoredText()
-- DESC : <research>
-- **************************************************************************
function TitanPalsUtils_GetColoredText(color, text)
	if ( text ) then
		if ( color == "gray" ) then return GRAY_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE; end
		if ( color == "red") then return RED_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE; end
		if ( color == "green" ) then return GREEN_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE; end
		if ( color == "orange") then return ORANGE_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE; end
		if ( color == "normal" ) then return NORMAL_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE; end
		if ( color == "highlight" ) then return HIGHLIGHT_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE; end
	end
end